#Скрипт для получения времени восхода и заката и обновления соотв. заданий
#http://www.outsidethebox.ms/20351

#Параметры запуска скрипта по умолчанию
##################################################################################
param(
#Широта и долгота: Москва, Красная площадь. Указывайте свои с карт Яндекс или Google.
  $lat = "55.753595",
  $lng = "37.621031"
)

#Общие переменные
##################################################################################
#Текущая датa в разных форматах
$date = Get-Date
$today = Get-Date -f "yyyy-MM-dd"

#Получить сведения о времени восхода и заката
$j = Invoke-RestMethod "https://api.sunrise-sunset.org/json?lat=$($lat)&lng=$($lng)&date=$($today)&formatted=0"
$sunrise = New-ScheduledTaskTrigger -Once -At $j.results.sunrise
$sunset = New-ScheduledTaskTrigger -Once -At $j.results.sunset

#Обновить время выполнения заданий, срабатывающих на восходе и закате
Set-ScheduledTask -TaskName "Sunrise" -Trigger $sunrise
Set-ScheduledTask -TaskName "Sunset" -Trigger $sunset

#Обработка сценария "пропущено назначенное время выполнения задания"
#Если текущее время между восходом и закатом, выполнить задание восхода
#Если текущее время после заката, выполнить задание заката
if (($date) -ge ($j.results.sunrise) -and ($date) -lt ($j.results.sunset)) {
	Start-ScheduledTask -TaskName "Sunrise"
}elseif (($date) -ge ($j.results.sunset)) {
	Start-ScheduledTask -TaskName "Sunset"
}
